From: Chao Yu <chao@kernel.org>
To: Zorro Lang <zlang@kernel.org>, fstests@vger.kernel.org
Cc: jaegeuk@kernel.org, linux-f2fs-devel@lists.sourceforge.net,
Chao Yu <chao@kernel.org>
Subject: [PATCH v4 6/6] f2fs/009: detect and repair nlink corruption
Date: Wed, 12 Mar 2025 15:23:09 +0800 [thread overview]
Message-ID: <20250312072309.3989074-6-chao@kernel.org> (raw)
In-Reply-To: <20250312072309.3989074-1-chao@kernel.org>
This is a regression test to check whether fsck can handle corrupted
nlinks correctly, it uses inject.f2fs to inject nlinks w/ wrong value,
and expects fsck.f2fs can detect such corruption and do the repair.
Cc: Jaegeuk Kim <jaegeuk@kernel.org>
Signed-off-by: Chao Yu <chao@kernel.org>
---
v4:
- remove unnecessary "_require_command fsck.f2fs"
- clean up _fixed_by_git_commit line
- fix to clean all tmp files in _cleanup
tests/f2fs/009 | 147 +++++++++++++++++++++++++++++++++++++++++++++
tests/f2fs/009.out | 2 +
2 files changed, 149 insertions(+)
create mode 100755 tests/f2fs/009
create mode 100644 tests/f2fs/009.out
diff --git a/tests/f2fs/009 b/tests/f2fs/009
new file mode 100755
index 00000000..9120d8a5
--- /dev/null
+++ b/tests/f2fs/009
@@ -0,0 +1,147 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2025 Chao Yu. All Rights Reserved.
+#
+# FS QA Test No. f2fs/009
+#
+# This is a regression test to check whether fsck can handle corrupted
+# nlinks correctly, it uses inject.f2fs to inject nlinks w/ wrong value,
+# and expects fsck.f2fs can detect such corruption and do the repair.
+#
+. ./common/preamble
+_begin_fstest auto quick
+
+if [ ! -x "$(type -P socket)" ]; then
+ _notrun "Couldn't find socket"
+fi
+
+_require_scratch
+_require_command "$F2FS_INJECT_PROG" inject.f2fs
+
+_fixed_by_git_commit f2fs-tools 958cd6e \
+ "fsck.f2fs: support to repair corrupted i_links"
+
+filename=$SCRATCH_MNT/foo
+hardlink=$SCRATCH_MNT/bar
+
+_cleanup()
+{
+ if [ -n "$pid" ]; then
+ kill $pid &> /dev/null
+ wait
+ fi
+ cd /
+ rm -r -f $tmp.*
+}
+
+for ((i=0;i<14;i++)) do
+ echo "round: " $i >> $seqres.full
+
+ _scratch_mkfs >> $seqres.full
+ _scratch_mount
+
+ if [ $i == 0 ]; then
+ touch $filename
+ ino=`stat -c '%i' $filename`
+ nlink=0
+ elif [ $i == 1 ]; then
+ mkdir $filename
+ ino=`stat -c '%i' $filename`
+ nlink=1
+ elif [ $i == 2 ]; then
+ mknod $filename c 9 0
+ ino=`stat -c '%i' $filename`
+ nlink=0
+ elif [ $i == 3 ]; then
+ mknod $filename b 8 0
+ ino=`stat -c '%i' $filename`
+ nlink=0
+ elif [ $i == 4 ]; then
+ mkfifo $filename
+ ino=`stat -c '%i' $filename`
+ nlink=0
+ elif [ $i == 5 ]; then
+ socket -s $filename >> $seqres.full 2>&1 &
+ pid=$!
+ sleep 2
+ ino=`stat -c '%i' $filename`
+ kill $pid >> $seqres.full 2>&1
+ nlink=0
+ elif [ $i == 6 ]; then
+ ln -s $SCRATCH_MNT/empty $filename
+ ino=`stat -c '%i' $filename`
+ nlink=0
+ elif [ $i == 7 ]; then
+ # orphan inode
+ touch $filename
+ ino=`stat -c '%i' $filename`
+ $F2FS_IO_PROG write 1 0 1 zero atomic_commit $filename 5000 >> $seqres.full 2>&1 &
+ stat $filename >> $seqres.full
+ rm $filename
+ $F2FS_IO_PROG shutdown 1 $SCRATCH_MNT/ >> $seqres.full
+ sleep 6
+ nlink=1
+ elif [ $i == 8 ]; then
+ # hardlink on file
+ touch $filename
+ ino=`stat -c '%i' $filename`
+ ln $filename $hardlink
+ nlink=0
+ elif [ $i == 9 ]; then
+ # hardlink on charactor
+ mknod $filename c 9 0
+ ino=`stat -c '%i' $filename`
+ ln $filename $hardlink
+ nlink=0
+ elif [ $i == 10 ]; then
+ # hardlink on blockdev
+ mknod $filename b 8 0
+ ino=`stat -c '%i' $filename`
+ ln $filename $hardlink
+ nlink=0
+ elif [ $i == 11 ]; then
+ # hardlink on pipe
+ mkfifo $filename
+ ino=`stat -c '%i' $filename`
+ ln $filename $hardlink
+ nlink=0
+ elif [ $i == 12 ]; then
+ # hardlink on socket
+ socket -s $filename >> $seqres.full 2>&1 &
+ pid=$!
+ sleep 2
+ ino=`stat -c '%i' $filename`
+ kill $pid >> $seqres.full 2>&1
+ ln $filename $hardlink
+ nlink=0
+ elif [ $i == 13 ]; then
+ # hardlink on symlink
+ ln -s $SCRATCH_MNT/empty $filename
+ ino=`stat -c '%i' $filename`
+ ln $filename $hardlink
+ nlink=0
+ fi
+
+ if [ $i != 7 ]; then
+ stat $SCRATCH_MNT/* >> $seqres.full
+ fi
+ echo "ino:"$ino >> $seqres.full
+ echo "nlink:"$nlink >> $seqres.full
+
+ _scratch_unmount
+
+ $F2FS_INJECT_PROG --node --mb i_links --nid $ino --val $nlink $SCRATCH_DEV \
+ >> $seqres.full || _fail "fail to inject"
+
+ _check_scratch_fs >> $seqres.full 2>&1 && _fail "can't find corruption"
+ _repair_scratch_fs >> $seqres.full
+ _check_scratch_fs >> $seqres.full 2>&1 || _fail "fsck can't fix corruption"
+
+ _scratch_mount
+ _scratch_unmount
+done
+
+echo "Silence is golden"
+
+status=0
+exit
diff --git a/tests/f2fs/009.out b/tests/f2fs/009.out
new file mode 100644
index 00000000..7e977155
--- /dev/null
+++ b/tests/f2fs/009.out
@@ -0,0 +1,2 @@
+QA output created by 009
+Silence is golden
--
2.48.1
next prev parent reply other threads:[~2025-03-12 7:23 UTC|newest]
Thread overview: 10+ messages / expand[flat|nested] mbox.gz Atom feed top
2025-03-12 7:23 [PATCH v4 1/6] common/config: remove redundant export variables Chao Yu
2025-03-12 7:23 ` [PATCH v4 2/6] common/config: export F2FS_INJECT_PROG Chao Yu
2025-03-12 7:23 ` [PATCH v4 3/6] common/config: export F2FS_FSCK_PROG Chao Yu
2025-03-12 7:23 ` [PATCH v4 4/6] common/rc: use -f for mkfs.f2fs by default Chao Yu
2025-03-12 7:23 ` [PATCH v4 5/6] common/rc: introduce _check_f2fs_filesystem() Chao Yu
2025-03-12 7:23 ` Chao Yu [this message]
2025-03-25 1:07 ` [PATCH v4 6/6] f2fs/009: detect and repair nlink corruption Zorro Lang
2025-03-25 6:54 ` Chao Yu
2025-03-25 9:15 ` Dave Chinner
2025-03-25 12:55 ` Chao Yu
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20250312072309.3989074-6-chao@kernel.org \
--to=chao@kernel.org \
--cc=fstests@vger.kernel.org \
--cc=jaegeuk@kernel.org \
--cc=linux-f2fs-devel@lists.sourceforge.net \
--cc=zlang@kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox